
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>首席工程师揭秘：LinkedIn大数据后台是如何运作的 / iVAN</title>

    <meta name="description" content="首席工程师揭秘：LinkedIn大数据后台是如何运作的 编者按: Jay Kreps是来自LinkedIn的首席工程师,他表示日志几乎在计算机产生的时候就存在,除了可用在分布式计算或者抽象分布式计算模型内部之外,还有广泛的用途.本文中他讲述的日志的原理和通过把日志用做单独服务来实现数据集成.实时数据处理以及分布式系统设计.文章内容非常干货,值得学习. 以下是原文: 我在六年前的一个令人兴奋的时刻加入到LinkedIn公司.从那个时候开始我们就破解单一的.集中式数据库的限制,并且启动到特殊的分布式系统套件的转换.这是一件令人兴奋的事情:我们构建.部署,">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">首席工程师揭秘：LinkedIn大数据后台是如何运作的</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>编者按：&nbsp;Jay Kreps是来自LinkedIn的首席工程师，他表示日志几乎在计算机产生的时候就存在，除了可用在分布式计算或者抽象分布式计算模型内部之外，还有广泛的用途。本文中他讲述的日志的原理和通过把日志用做单独服务来实现数据集成、实时数据处理以及分布式系统设计。文章内容非常干货，值得学习。</p>
<p>以下是原文：</p>
<p>我在六年前的一个令人兴奋的时刻加入到LinkedIn公司。从那个时候开始我们就破解单一的、集中式数据库的限制，并且启动到特殊的分布式系统套件的转换。这是一件令人兴奋的事情：我们构建、部署，而且直到今天仍然在运行的分布式图形数据库、分布式搜索后端、Hadoop安装以及第一代和第二代键值数据存储。</p>
<p>从这一切里我们体会到的最有益的事情是我们构建的许多东西的核心里都包含一个简单的理念：日志。有时候也称作预先写入日志或者提交日志或者事务日志，日志几乎在计算机产生的时候就存在，同时它还是许多分布式数据系统和实时应用结构的核心。</p>
<p>不懂得日志，你就不可能完全懂得数据库，NoSQL存储，键值存储，复制，paxos,Hadoop,版本控制以及几乎所有的软件系统；然而大多数软件工程师对它们不是很熟悉。我愿意改变这种现状。在这篇博客文章里，我将带你浏览你必须了解的有关日志的所有的东西，包括日志是什么，如何在数据集成、实时处理和系统构建中使用日志等。</p>
<p>第一部分：日志是什么？</p>
<p>日志是一种简单的不能再简单的存储抽象。它是一个只能增加的，完全按照时间排序的一系列记录。日志看起来如下：</p>
<p>我们可以给日志的末尾添加记录，并且可以从左到右读取日志记录。每一条记录都指定了一个唯一的有一定顺序的日志记录编号。<br />
<br />日志记录的排序是由“时间”来确定的，这是因为位于左边的日志记录比位于右边的要早些。日志记录编号可以看作是这条日志 记录的“时间戳”。在一开始就把这种排序说成是按时间排序显得有点多余 ，不过 ，与任何一个具体的物理时钟相比，时间 属性是非常便于使用的属性。在我们运行多个分布式系统的时候，这个属性就显得非常重要。</p>
<p>对于这篇讨论的目标而言，日志记录的内容和格式不怎么重要。另外提醒一下，在完全耗尽存储空间的情况下，我们不可能 再给日志添加记录。稍后我们将会提到这个问题。</p>
<p>日志并不是完全不同于文件或者数据表的。文件是由一系列字节组成，表是由一系列记录组成，而日志实际上只是按照时间顺序存储记录的 一种数据表或者文件。</p>
<p>此时，你可能奇怪为什么要讨论这么简单的事情呢？ 不同环境下的一个只可增加的有一定顺序的日志记录是怎样与数据系统关联起来的呢？答案是日志有其特定的应用目标：它记录了什么时间发生了什么事情。 而对分布式数据系统许多方面而言， 这才是问题的真正核心。</p>
<p>不过，在我们进行更加深入的讨论之前，让我先澄清有些让人混淆的概念。每个编程人员都熟悉另一种日志记录-应用使用syslog或者log4j可能写入到本地文件里的没有结构的错误信息或者追踪信息。为了区分开来，我们把这种情形的日志记录称为“应用日志记录”。应用日志记录是我在这儿所说的日志的一种低级的变种。最大的区别是：文本日志意味着主要用来方便人们阅读，而我所说明的“日志”或者“数据日志”的建立是方便程序访问。</p>
<p>（实际上，如果你对它进行深入的思考，那么人们读取某个机器上的日志这种理念有些不顺应时代潮流。当涉及到许多服务和服务器的时候，这种方法很快就变成一个难于管理的方式，而且为了认识多个机器的行为，日志的目标很快就变成查询和图形化这些行为的输入了-对多个机器的某些行为而言，文件里的英文形式的文本同这儿所描述的这种结构化的日志相比几乎就不适合了。）</p>
<p>数据库日志</p>
<p>我不知道日志概念起源于何处-可能它就像二进制搜索一样：发明者认为它太简单而不能当作一项发明。它早在IBM的系统R出现时候就出现了。数据库里的用法是在崩溃的时候用它来同步各种数据结构和索引。为了保证操作的原子性和持久性，在对数据库维护的所有各种数据结构做更改之前，数据库把即将修改的信息誊写到日志里。日志记录了发生了什么，而且其中的每个表或者索引都是一些数据结构或者索引的历史映射。由于日志是即刻永久化的，可以把它当作崩溃发生时用来恢复其他所有永久性结构的可信赖数据源。</p>
<p>随着时间的推移，日志的用途从实现ACID细节成长为数据库间复制数据的一种方法。利用日志的结果就是发生在数据库上的更改顺序与远端复制数据库上的更改顺序需要保持完全同步。</p>
<p>Oracle,MySQL 和PostgreSQL都包括用于给备用的复制数据库传输日志的日志传输协议。Oracle还把日志产品化为一个通用的数据订阅机制，这样非Oracle数据订阅用户就可以使用XStreams和GoldenGate订阅数据了，MySQL和PostgreSQL上的类似的实现则成为许多数据结构的关键组件。&nbsp;<br /> 正是由于这样的起源，机器可识别的日志的概念大部分都被局限在数据库内部。日志用做数据订阅的机制似乎是偶然出现的，不过要把这种 抽象用于支持所有类型的消息传输、数据流和实时数据处理是不切实际的。</p>
<p>分布式系统日志<br />
<br />日志解决了两个问题：更改动作的排序和数据的分发，这两个问题在分布式数据系统里显得尤为重要。协商出一致的更改动作的顺序（或者说保持各个子系统本身的做法，但可以进行存在副作用的数据拷贝）是分布式系统设计的核心问题之一。</p>
<p>以日志为中心实现分布式系统是受到了一个简单的经验常识的启发，我把这个经验常识称为状态机复制原理：如果两个相同的、确定性的进程从同一状态开始，并且以相同的顺序获得相同的输入，那么这两个进程将会生成相同的输出，并且结束在相同的状态。</p>
<p>这也许有点难以理解，让我们更加深入的探讨，弄懂它的真正含义。</p>
<p>确定性意味着处理过程是与时间无关的，而且任何其他“外部的“输入不会影响到处理结果。例如，如果一个程序的输出会受到线程执行的具体顺序影响，或者受到gettimeofday调用、或者其他一些非重复性事件的影响，那么这样的程序一般最有可能被认为是非确定性的。</p>
<p>进程状态是进程保存在机器上的任何数据，在进程处理结束的时候，这些数据要么保存在内存里，要么保存在磁盘上。</p>
<p>以相同的顺序获得相同输入的地方应当引起注意-这就是引入日志的地方。这儿有一个重要的常识：如果给两段确定性代码相同的日志输入，那么它们就会生成相同的输出。</p>
<p>分布式计算这方面的应用就格外明显。你可以把用多台机器一起执行同一件事情的问题缩减为实现分布式一致性日志为这些进程输入的问题。这儿日志的目的是把所有非确定性的东西排除在输入流之外，来确保每个复制进程能够同步地处理输入。</p>
<p>当你理解了这个以后，状态机复制原理就不再复杂或者说不再深奥了：这或多或少的意味着“确定性的处理过程就是确定性的”。不管怎样，我都认为它是分布式系统设计里较常用的工具之一。</p>
<p>这种方式的一个美妙之处就在于索引日志的时间戳就像时钟状态的一个副本——你可以用一个单独的数字描述每一个副本，这就是经过处理的日志的时间戳。时间戳与日志一一对应着整个副本的状态。</p>
<p>由于写进日志的内容的不同，也就有许多在系统中应用这个原则的不同方式。举个例子，我们记录一个服务的请求，或者服务从请求到响应的状态变化，或者它执行命令的转换。理论上来说，我们甚至可以为每一个副本记录一系列要执行的机器指令或者调用的方法名和参数。只要两个进程用相同的方式处理这些输入，这些进程就会保持副本的一致性。</p>
<p>一千个人眼中有一千种日志的用法。数据库工作者通常区分物理日志和逻辑日志。物理日志就是记录每一行被改变的内容。逻辑日志记录的不是改变的行而是那些引起行的内容被改变的SQL语句（insert，update和delete语句）。</p>
<p>分布式系统通常可以宽泛分为两种方法来处理数据和完成响应。“状态机器模型”通常引用一个主动-主动的模型——也就是我们为之记录请求和响应的对象。对此进行一个细微的更改，称之为“预备份模型”，就是选出一个副本做为leader，并允许它按照请求到达的时间来进行处理并从处理过程中输出记录其状态改变的日志。其他的副本按照leader状态改变的顺序而应用那些改变，这样他们之间达到同步，并能够在leader失败的时候接替leader的工作。</p>
<p>为了理解两种方式的不同，我们来看一个不太严谨的例子。假定有一个算法服务的副本，保持一个独立的数字作为它的状态（初始值为0），并对这个值进行加法和乘法运算。主动-主动方式应该会输出所进行的变换，比如“+1”，“*2”等。每一个副本都会应用这些变换，从而得到同样的解集。主动-被动方式将会有一个独立的主体执行这些变换并输出结果日志，比如“1”，“3”，“6”等。这个例子也清楚的展示了为什么说顺序是保证各副本间一致性的关键：一次加法和乘法的顺序的改变将会导致不同的结果。</p>
<p>分布式日志可以理解为一致性问题模型的数据结构。因为日志代表了后续追加值的一系列决策。你需要重新审视Paxos算法簇，尽管日志模块是他们最常见的应用。 在Paxos算法中，它通常通过使用称之为多paxos的协议，这种协议将日志建模为一系列的问题，在日志中每个问题都有对应的部分。在ZAB， RAFT等其它的协议中，日志的作用尤为突出，它直接对维护分布式的、一致性的日志的问题建模。</p>
<p>我怀疑的是，我们就历史发展的观点是有偏差的，可能是由于过去的几十年中，分布式计算的理论远超过了其实际应用。在现实中，共识的问题是有点太简单了。计算机系统很少需要决定单个值，他们几乎总是处理成序列的请求。这样的记录，而不是一个简单的单值寄存器，自然是更加抽象。</p>
<p>此外，专注于算法掩盖了 抽象系统需要的底层的日志。我怀疑，我们最终会把日志中更注重作为一个商品化的基石，不论其是否以同样的方式 实施的，我们经常谈论一个哈希表而不是纠结我们 得到是不是具体某个细节的哈希表，例如线性或者带有什么什么其它变体哈希表。日志将成为一种大众化的接口，为大多数算法和其实现提升提供最好的保证和最佳的性能。</p>
<p>变更日志101： 表与事件的二相性。</p>
<p>让我们继续聊数据库。数据库中存在着大量变更日志和表之间的二相性。这些日志有点类似借贷清单和银行的流程，数据库表就是当前的盈余表。如果你有大量的变更日志，你就可以使用这些变更用以创建捕获当前状态的表。这张表将记录每个关键点（日志中一个特别的时间点）的状态信息。这就是为什么日志是非常基本的数据结构的意义所在：日志可用来创建基本表，也可以用来创建各类衍生表。同时意味着可以存储非关系型的对象。</p>
<p>这个流程也是可逆的：如果你正在对一张表进行更新，你可以记录这些变更，并把所有更新的日志发布到表的状态信息中。这些变更日志就是你所需要的支持准实时的克隆。基于此，你就可以清楚的理解表与事件的二相性： 表支持了静态数据而日志捕获变更。日志的魅力就在于它是变更的完整记录，它不仅仅捕获了表的最终版本的内容，它还记录了曾经存在过的其它版本的信息。日志实质上是表历史状态的一系列备份。</p>
<p>这可能会引起你对源代码的版本管理。源代码管理和数据库之间有密切关系。版本管理解决了一个大家非常熟悉的问题，那就是什么是分布式数据系统需要解决的— 时时刻刻在变化着的分布式管理。版本管理系统通常以补丁的发布为基础，这实际上可能是一个日志。您可以直接对当前 类似于表中的代码做出“快照”互动。你会注意到， 与其他分布式状态化系统类似，版本控制系统 当你更新时会复制日志，你希望的只是更新补丁并将它们应用到你的当前快照中。</p>
<p>最近，有些人从Datomic –一家销售日志数据库的公司得到了一些想法。这些想法使他们对如何 在他们的系统应用这些想法有了开阔的认识。 当然这些想法不是只针对这个系统，他们会成为 十多年分布式系统和数据库文献的一部分。</p>
<p>这可能似乎有点过于理想化。但是不要悲观！我们会很快把它实现。</p>
<p>(责任编辑：蒙遗善)</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-04 11:02:59</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%88%96%e8%80%85/" title="或者">或者</a>, <a href="https://www.iamivan.net/tag/nbsp/" title="nbsp">nbsp</a>, <a href="https://www.iamivan.net/tag/%e5%8f%af%e4%bb%a5/" title="可以">可以</a>, <a href="https://www.iamivan.net/tag/%e6%88%91%e4%bb%ac/" title="我们">我们</a>, <a href="https://www.iamivan.net/tag/%e8%bf%99%e4%ba%9b/" title="这些">这些</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>首席工程师揭秘：LinkedIn大数据后台是如何运作的的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9YB34M.html" rel="bookmark">LinkedIn大数据专家深度解读日志的意义</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				文章讲的是LinkedIn大数据专家深度解读日志的意义,我在六年前的一个令人兴奋的时刻加入到LinkedIn公司.从那个时候开始我们就破解单一的.集中式数据库的限制,并且启动到特殊的分布式系统套件的转换.这是一件令人兴奋的事情:我们构建.部署,而且直到今天仍然在运行的分布式图形数据库.分布式搜索后端.Hadoop安装以及第一代和第二代键值数据存储. 从这一切里我们体会到的最有益的事情是我们构建的许多东西的核心里都包含一个简单的理念:日志.有时候也称作预先写入日志或者提交日志或者事务日志,日志几乎			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqRdg2p.html" rel="bookmark">CNCC 人物专访 谭晓生（上）&vert; 360 首席隐私官谈大数据与个人隐私的博弈</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				     现任奇虎 360 科技有限公司首席隐私官,2013 中国互联网安全大会主席. 2009 年 7 月加盟北京奇虎科技有限公司担任副总裁,负责公司网站技术.技术运维.数据分析与挖掘.云查杀.云存储等业务的技术团队管理. 1992 年毕业于西安交通大学计算机科学与工程系计算机应用专业.2003 年 1 月至今先后任 3721 技术开发总监.雅虎中国技术开发总监.雅虎中国 CTO.阿里巴巴-雅虎中国技术研发部总监.还曾任 MySpace CTO 兼任 COO. 目前还担任 CCF 副秘书长,Y			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDQZWXb.html" rel="bookmark">LinkedIn 大数据应用 以及 Azkaban</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				LinkedIn 大数据应用 以及 Azkaban • 列举主要的大数据应用 • Hadoop 平台和技术 • 作业流管理平台 Azkaban LinkedIn 大数据应用 以及 Azkaban			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGEnZOM.html" rel="bookmark">2016中国大数据企业排行榜发布&mdash;&mdash;首席数据官联盟揭秘中国大数据如何发展</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ZD至顶网服务器频道 07月15日 新闻消息: 2016年7月14号,首席数据官联盟在京发布了2016年&lt;中国大数据企业排行榜&gt;.本次发布的&lt;中国大数据企业排行榜&gt;由北京大学电子政务研究院.中国新一代IT产业推进联盟共同指导,由首席数据官联盟专家组依据大数据企业评价指标体系对国内大数据企业进行综合评定.与此同时专家组还总结出了中国大数据发展的10大趋势和5大挑战.   此次&lt;中国大数据企业排行榜&gt;得到业界的大力支持,发布会由中华网.中关村智能硬件产业联盟.北京优智活孵化			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MA71Pvz.html" rel="bookmark">国信优易首席科学家周涛：大数据的商业应用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				国信优易首席科学家周涛认为,大数据已经成为一个非常热的概念,但是当一个概念热到一定程度就会存在风险,甚至风险比机会还多.在大数据沙龙中,他和数据从业者们分享了自己所经历的大数据应用. 以下为周涛发言: 大数据的应用创新可以分成4个阶段,我以一些公司为案例来说明. 1.简单的数据集中 我们做过一家企业--数联铭品,它是做企业征信的.我们把工商数据和法律数据(包括法院已经诉讼完和在诉的案件).纪检.知识产权部门.项目申报.企业招聘数据.企业舆情数据等数据都爬下来.之后我们就可以做出企业的画像,知道一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXqKRyz.html" rel="bookmark">数联铭品首席科学家周涛：大数据海洋中的教授级创业家</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				几天前,在世界互联网大会上马云表示,&quot;这一次互联网技术革命,解放了脑力,数据成为核心资源.未来,数据是生产资料,计算是生产力&quot;. 大数据到底会对我们的生活产生怎样的深刻影响?资本为何对大数据追捧有加?大数据商用的投资机会在哪里?2016年11月25日,由每日经济新闻主办的&quot;2016第五届中国上市公司领袖峰会&quot;也许会给你一个答案. &quot;80后&quot;最年轻教授.创立多家大数据企业的教授级创业家,一位成功从国内大数据行业理论界走向实业界的代表--电子科技大学			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNmO7xb.html" rel="bookmark">揭秘IBM大数据大学 为40万学生提供免费在线学习</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				据福布斯杂志报道,科技界和学术界都预测,由于缺少数据科学和分析科学技能,未来数年将有大量资金被浪费,同时无数机遇被错过.传统学术机构已经开始致力于填补这个空白.但是,大多数热门技术课程(比如机器学习.预测建模)等都属于研究生水平,进入的门槛更高.这就为在线远程学习供应商提供了机会,他们可以更灵活地适应需求. 尽管这个领域已经有很多初创企业,但老牌科技巨头IBM再次掀起波澜.IBM所属大数据大学已经拥有40多万名学生.IBM大数据大学的在线课程不收取任何费用,其以企业为中心的教育方式也不同于其他在			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9NGgvp.html" rel="bookmark">深度揭秘：大数据时代企业卖技术还是卖数据&quest;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				大数据技术的热度这几年一直在上升,现在我们在谈论大数据的时候已经不再仅仅局限于炒作大数据的概念了,更多的是聚焦在一些大数据的具体应用上,作为企业用户来讲,现在也已经开始有越来越多的企业领导和IT管理者逐渐了解大数据同自身业务之间的联系.  我们都知道,当今的企业级市场,不管是渠道市场还是行业市场,数据对于企业来说都存在着巨大的价值,而作为数据资源的核心组成部分,大数据已经成为了很多企业愿意买单的&quot;产品&quot;.其实企业在购买大数据服务的原因很简单,就是利用大数据的技术和应用帮助企业进行开源节			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLJ05kb.html" rel="bookmark">上海将设大数据交易中心 市场化民营化运作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上海市大数据交易中心的设立渐进,上海市政府已经审议通过了该交易中心的规划和建设方案. 1月26日,上海市副市长周波在参加上海市十四届人大第四次会议的&quot;互联网+行动计划&quot;专题审议时表示,我们不简单追求时间上的第一,而是追求质量上第一,规模上第一. 随着&quot;互联网+&quot;的推进,大数据产业的价值正在凸显.2015年4月14日,全国首家大数据交易所落户贵阳,此后,不少城市也开始酝酿发展大数据交易系统,近期北京大数据交易服务平台.华中大数据交易所纷纷投入运营. 市场调研机构IDC			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWKojM.html" rel="bookmark" class="title">DIV&plus;CSS页面布局中BUG解决方法</a>
					<div>
						DIV+CSS布局中,出现BUG之后,可以考虑从以下几方面检查. 一.检查页面的标签是否闭合 不要小看这条,也许折腾了你两天都没有解决的 CSS BUG 问题,却仅仅源于这里.毕竟页面的模板一般都是由 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqJ2Kp.html" rel="bookmark" class="title">解决杀毒软件误删asp文件的方法</a>
					<div>
						一些杀毒软件经常会把某些asp文件当成病毒删除,有时简直防不胜防,程序莫名其妙的就不能用了,因为少了文件呀~~.这主要是因为,杀毒软 件将某些asp代码当成木马关键词,记录保存着,所以遇到有这个关键词 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbK8w5M.html" rel="bookmark" class="title">IT新技术名词：AJAX和SOAP&mdash;&mdash;异步数据和XML获取</a>
					<div>
						ajax|xml|数据|异步 IT新技术名词:AJAX和SOAP--异步数据和XML获取 AJAX:原文Asynchronous Javascript and XML applications,其实就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0boZQjz.html" rel="bookmark" class="title">做网站，坚持和行动最重要</a>
					<div>
						越来越多的新站出现,也就造成了越来越多的垃圾站,一个个倒下,周而复始,本来现在的形势不是很好,造成了互联网的极大浪费. 虽然现在的互联网充斥着各个方向的网站,但并不是有人做过就一定没有前途,只要你认真 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bB55dz.html" rel="bookmark" class="title">字符集问题的初步探讨&lpar;五&rpar;</a>
					<div>
						问题 原文链接: http://www.eygle.com/special/NLS_CHARACTER_SET_05.htm 原文发表于itpub技术丛书&lt;Oracle数据库DBA专题技术精粹& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAmlXM.html" rel="bookmark" class="title">用FireWorks画大众甲壳虫</a>
					<div>
						我不怎么会写教程,只好介绍一下我的作画过程,技术比较拙劣,介绍也比较简单,希望大家不要见笑.本次作画使用软件:Fireworks    下面我们先拿出一张汽车原图作参考来画.     原图     用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk2xXwM.html" rel="bookmark" class="title">LINQ to SQL语句&lpar;10&rpar;之Insert</a>
					<div>
						插入(Insert)1.简单形式 说明:new一个对象,使用InsertOnSubmit方法 将其加入到对应的集合中,使用SubmitChanges()提交到数据库. NorthwindDataCon ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKEj4p.html" rel="bookmark" class="title">如何实现从Sybase到Oracle连接服务器</a>
					<div>
						 不同数据库平台的互连一般称之为数据库的异构服务,现在各大数据库之间都可以实现这样的异构互连,只是各厂商的具体实现技术不一样,如:在SYBASE里面叫做CONNECT OR CONNECTION PR ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBaZYz.html" rel="bookmark" class="title">aspx-提示找不到xxx&period;cs文件</a>
					<div>
						问题描述 提示找不到xxx.cs文件 aspx/ascx文件的代码文件声明CodeFile=''无法编译 提示找不到xxx.cs文件. 解决方案 应该是你复制了一个页面,然后忘了改名					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b24jxkp.html" rel="bookmark" class="title">Java中自然排序和比较器排序详解&lowbar;java</a>
					<div>
						前言 当指执行插入排序.希尔排序.归并排序等算法时,比较两个对象&quot;大小&quot;的比较操作.我们很容易理解整型的 i&gt;j 这样的比较方式,但当我们对多个对象进行排序时,如何比较两个对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr3x5mp.html" rel="bookmark" class="title">WordPress开发中自定义菜单的相关PHP函数使用简介&lowbar;php技巧</a>
					<div>
						函数意义wp_nav_menu () 自定义菜单显示函数 register_nav_menu () 自定义菜单注册函数 – 单数 register_nav_menus () 自定义菜单注册函数 – 复 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm66Vlz.html" rel="bookmark" class="title">java-ibatis如果传入list参数 数据库查不到结果集时报下标越界错误</a>
					<div>
						问题描述 ibatis如果传入list参数 数据库查不到结果集时报下标越界错误 用ibatis传入的一个list集合 需要用到其中的主键ID, 但是其中只有某些ID可以查到结果集,这样的话ibatis ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8kD1NM.html" rel="bookmark" class="title">怎么在Android tv的activity上显示vga的视频啊。</a>
					<div>
						问题描述 怎么在Android tv的activity上显示vga的视频啊. 项目开发要求在安卓TV的app上显示vga的视频.高手,救命啊.怎么弄?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPryqp.html" rel="bookmark" class="title">css 3d旋转</a>
					<div>
						&lt;!DOCTYPE html&gt; &lt;html&gt; &lt;head&gt; &lt;meta charset=&quot;utf-8&quot;/&gt; &lt;meta nam ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZAwDz.html" rel="bookmark" class="title">easyui dialog向加载的jsp传递的值无法获取</a>
					<div>
						问题描述 easyui dialog向加载的jsp传递的值无法获取 function openWindow(rowData){ var title = 'dialog'; var url = 'app ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXqQOz.html" rel="bookmark" class="title">如何10分钟搞定撞库</a>
					<div>
						近期,阿里云云盾安全团队检测到越来越多的撞库攻击事件,在大数据应用越来越广泛的今天,撞库攻击带来的危害也越来越不容忽视.那么何为撞库攻击?撞库对用户可能有哪些危害?还有最关键的,作为大多数专注业务发展 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKjj3b.html" rel="bookmark" class="title">求 助-各位大大帮帮忙啊，刚刚按照课本写了些码，但是运行结果不一样</a>
					<div>
						问题描述 各位大大帮帮忙啊,刚刚按照课本写了些码,但是运行结果不一样 这是我写的,书上的运行结果是输入两个数字就可以得到一个C结果 但我运行的结果就是输入两个字然后就没反应了得不出C啊 我用的是VS2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxYVZRp.html" rel="bookmark" class="title">亚马逊出自家处理器Alpine 适用于物联网设备</a>
					<div>
						亚马逊从在线书店发展到现在的电子商务巨头,经历了漫长的过程,而现在,除了各种各样的商品之外,亚马逊还销售自家研发的Kindle电子阅读器和平板电脑一类的商品,甚至还有原创的在线流媒体视频.云计算等各种 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBqlKM.html" rel="bookmark" class="title">Linux块设备驱动之NAND FLASH</a>
					<div>
						讲解驱动最好的办法是看代码,然后看注释,相信凭你的智慧能够轻松理解的.有些人就会问了,我怎么看不懂呢?这里我得声明一下了,你如果连LED驱动都没有写过,驱动的框架你又怎么会了解呢?   写驱动的人只需 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7kXkM.html" rel="bookmark" class="title">submit-android 设备的兼容性</a>
					<div>
						问题描述 android 设备的兼容性 我创建了一个简答的程序,在android中只能使用 swipe gestures.但是当我把它加载到Play store时,却显示没有设备能使用它. 下面是 P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAe35b.html" rel="bookmark" class="title">javascript计时器事件使用详解&lowbar;基础知识</a>
					<div>
						在 JavaScritp 中使用计时事件是很容易的,两个关键方法是: setTimeout()未来的某时执行代码 clearTimeout()取消setTimeout()setTimeout()语法  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60q3Jz.html" rel="bookmark" class="title">微微拼车助力APEC 招募荣誉车主</a>
					<div>
						APEC亚太峰会开始在即,&quot;放假辟谣&quot;风波也告一段落,届时11月7日到11月12日在京中央国家http://www.aliyun.com/zixun/aggregation/310 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodo73M.html" rel="bookmark" class="title">问个问题&quest;&quest;&quest;&quest;&quest;</a>
					<div>
						问题描述 问个问题我通过pty3给pty0发送了top怎么通过pty2给pty0发送键盘输入?我在使用mysqlcluster时如果程序数据库连接到某个节点了然后这个节点down了或者mysql挂了已 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0NnD7z.html" rel="bookmark" class="title">windows下控制面版中各个项目的绝对路径&lowbar;应用技巧</a>
					<div>
						直接运行这些cpl就可以不用进控制面版了 Internet选项 C:\WINDOWS\System32\inetcpl.cpl 电话和调制解调器选项 C:\WINDOWS\System32\telep ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOqEDb.html" rel="bookmark" class="title">Docker 修改文件是否需要重启（命令详解）&lowbar;docker</a>
					<div>
						Docker 修改文件是否需要重启               Docker 修改文件是否需要重启,在做项目的时候,经常会修改文件,对于命令不是多了解,用了也是试试的态度,这里就整理下该如何使用,提高 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0n4xp.html" rel="bookmark" class="title">node&period;js中的console&period;info方法使用说明&lowbar;node&period;js</a>
					<div>
						方法说明: 该方法与 console.log() 相同.从源码看,它是直接调用console.log的. 语法: 复制代码 代码如下: console.info([data], [...]) 接收参数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6GyxOp.html" rel="bookmark" class="title">用CSS设计的导航实例</a>
					<div>
						www.jscode.cn www.jscode.cn www.jscode.cn www.jscode.cn www.jscode.cn					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDkD80p.html" rel="bookmark" class="title">关于&amp;amp&semi;amp&semi;quot&semi;&amp;amp&semi;amp&semi;lt&semi;&amp;amp&semi;amp&semi;quot&semi;和&amp;amp&semi;amp&semi;quot&semi;&amp;amp&semi;amp&semi;gt&semi;&amp;amp&semi;amp&semi;quot&semi;等符号的显示问题</a>
					<div>
						问题描述 大家都知道&lt;=&lt;&gt;=&gt;'=&quot;等等...如果我的数据库某记录是&lt;fontsize=&quot;5&quot;&gt;内容&lt;/font&gt;浏览器 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmQDAz.html" rel="bookmark" class="title">英特尔：5G将释放云的潜力，为垂直行业带来巨大商机</a>
					<div>
						6月28日至7月1日, 2017年世界移动大会(MWCS 2017)在上海举行.在此次大会上,英特尔数据中心事业部副总裁兼5G网络基础设施部门总经理林怡颜分享了她对于5G的观点,解读了网络转型和MEC ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1E2Zb.html" rel="bookmark" class="title">java-Java语言程序设计第八版基础篇的编程练习</a>
					<div>
						问题描述 Java语言程序设计第八版基础篇的编程练习 为什么按照下面的运行实例的数进行输入所得的结果却不同import java.util.Scanner; public class FutureIn ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
